/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wawi.gui.admingui.gui;

import java.awt.Color;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import static javax.swing.JOptionPane.showMessageDialog;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import wawi.fachlogik.adminsteuerung.grenz.BestellungGrenz;
import wawi.fachlogik.adminsteuerung.steuer.BestellungSteuerung;
import wawi.gui.admingui.resources.MyListModelBestellungen;

/**
 *
 * @author gromow
 */
public class FrameBestellungenShow extends javax.swing.JFrame {

    private FrameBestellungPositionShow frameBestellungPositionenShow;
    //static da diese Variable übergegeben wird
    public static int hiddenValueForBestellung;
    private MyListModelBestellungen mylistmodelbestellungen;
    private BestellungSteuerung bs;
    private BestellungGrenz bestellunggrenz;
    private List<BestellungGrenz> bestellunggrenzlist;
    private Date datevon;
    private Date datebis;

    /**
     * Creates new form FrameBestellungenShow
     */
    public FrameBestellungenShow() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        bestellungPositionenShow = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        fieldVon = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        fieldBis = new javax.swing.JTextField();
        searchDate = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        fielById = new javax.swing.JTextField();
        searchById = new javax.swing.JButton();
        close = new javax.swing.JButton();
        lblOutput = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Bestellungen");

        bestellungPositionenShow.setText("Bestellungspositionen anzeigen");
        bestellungPositionenShow.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        bestellungPositionenShow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bestellungPositionenShowActionPerformed(evt);
            }
        });

        bs = new BestellungSteuerung();
        List<BestellungGrenz> bestellunggrenzlist = bs.bestellungenAnzeigen();
        MyListModelBestellungen mylistmodelbestellungen = new MyListModelBestellungen();
        mylistmodelbestellungen.setBestellunggrenzlist(bestellunggrenzlist);
        /*Dummy*/
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Dummy", "Dummy", "Dummy", "Dummy"
            }
        ));
        /*Ende Dummy*/
        jTable1.setModel(mylistmodelbestellungen.buildTableModel());
        /* Listener Event aus Google */
        jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener(){
            public void valueChanged(ListSelectionEvent event) {
                // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                // print first column value from selected row
                String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();
                hiddenValueForBestellung = Integer.parseInt(val);

                lblOutput.setForeground(Color.BLACK);
                lblOutput.setText("Bestellung : "+hiddenValueForBestellung);
            }
        });
        //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
        for (int c = 0; c < jTable1.getColumnCount(); c++)
        {
            Class<?> col_class = jTable1.getColumnClass(c);
            jTable1.setDefaultEditor(col_class, null);        // remove editor
        }

        /* Listener Event aus Google */
        jScrollPane1.setViewportView(jTable1);

        jLabel2.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel2.setText("Suchoptionen");

        jLabel3.setText("von");

        fieldVon.setText("tt-mm-jjjj");
        fieldVon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fieldVonActionPerformed(evt);
            }
        });

        jLabel4.setText("bis");

        //PromptSupport.setPrompt("777", fieldBis);
        fieldBis.setText("tt-mm-jjjj");
        fieldBis.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fieldBisActionPerformed(evt);
            }
        });

        searchDate.setText("Filtern");
        searchDate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchDateActionPerformed(evt);
            }
        });

        jLabel5.setText("ID:");

        fielById.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fielByIdActionPerformed(evt);
            }
        });

        searchById.setText("Suchen");
        searchById.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchByIdActionPerformed(evt);
            }
        });

        close.setText("Schließen");
        close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeActionPerformed(evt);
            }
        });

        lblOutput.setText(" ");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(368, 368, 368)
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(109, 109, 109)
                        .addComponent(bestellungPositionenShow))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(14, 14, 14)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(lblOutput)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(12, 12, 12)
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fieldVon, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jLabel4)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fieldBis, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(searchDate)
                                .addGap(49, 49, 49)
                                .addComponent(jLabel5)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fielById, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(searchById, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(close, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {close, searchById, searchDate});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(bestellungPositionenShow))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 246, Short.MAX_VALUE)
                .addGap(15, 15, 15)
                .addComponent(lblOutput)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(fieldVon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(fieldBis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(searchDate)
                    .addComponent(jLabel5)
                    .addComponent(fielById, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(searchById)
                    .addComponent(close))
                .addGap(17, 17, 17))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bestellungPositionenShowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bestellungPositionenShowActionPerformed
        frameBestellungPositionenShow = new FrameBestellungPositionShow();
        frameBestellungPositionenShow.setTitle("Bestellungsposition anzeigen");
        frameBestellungPositionenShow.setVisible(true);
    }//GEN-LAST:event_bestellungPositionenShowActionPerformed

    private void closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeActionPerformed
        // TODO add your handling code here:
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        dispose();
    }//GEN-LAST:event_closeActionPerformed

    private void searchByIdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchByIdActionPerformed
        //jTable1 muss deklariert werden
        if (fielById.getText().equals("")) {
            showMessageDialog(null, "Tragen Sie Bitte id-Nummer ein!");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");

        } else {
            jTable1 = new javax.swing.JTable();

            bs = new BestellungSteuerung();

            hiddenValueForBestellung = Integer.parseInt(fielById.getText());

            bestellunggrenz = bs.bestellungenAnzeigen(hiddenValueForBestellung);
            if (bestellunggrenz == null) {
                showMessageDialog(null, "Nichts gefunden!");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");
            } else {
                List<BestellungGrenz> bestellunggrenzlist = new ArrayList<>();
                bestellunggrenzlist.add(bestellunggrenz);

                mylistmodelbestellungen = new MyListModelBestellungen();

                mylistmodelbestellungen.setBestellunggrenzlist(bestellunggrenzlist);

                jTable1.setModel(mylistmodelbestellungen.buildTableModel());
                /* Listener Event aus Google */

                jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                    public void valueChanged(ListSelectionEvent event) {
                        // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                        // print first column value from selected row
                        String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();

                        hiddenValueForBestellung = Integer.parseInt(val);
                        lblOutput.setText("Bestellung : " + hiddenValueForBestellung);
                    }
                });

                //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
                for (int c = 0; c < jTable1.getColumnCount(); c++) {
                    Class<?> col_class = jTable1.getColumnClass(c);
                    jTable1.setDefaultEditor(col_class, null);        // remove editor
                }
                jScrollPane1.setViewportView(jTable1);
            }
            /* Listener Event aus Google */
        }
    }//GEN-LAST:event_searchByIdActionPerformed

    private void fielByIdActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fielByIdActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fielByIdActionPerformed

    private void searchDateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchDateActionPerformed
        // TODO add your handling code here:
        String von = fieldVon.getText();
        String bis = fieldBis.getText();

        if (von.equals("") || bis.equals("") || bis.contains("m") || von.contains("m")) {
            showMessageDialog(null, "Datum bitte eingeben");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");

        } else {
            jTable1 = new javax.swing.JTable();
            bs = new BestellungSteuerung();

            //String ins Datum umwandeln
            DateFormat formatter = new SimpleDateFormat("dd-MM-yyyy");

            try {
                datevon = formatter.parse(von);
                datebis = formatter.parse(bis);
            } catch (ParseException ex) {
                Logger.getLogger(FrameBestellungenShow.class.getName()).log(Level.SEVERE, null, ex);
            }

            try {
                bestellunggrenzlist = bs.bestellungenAnzeigen(datevon, datebis);
                lblOutput.setText("Gefundene Einträge: " + bestellunggrenzlist.size());
            } catch (ParseException ex) {
                Logger.getLogger(FrameBestellungenShow.class.getName()).log(Level.SEVERE, null, ex);
            }

            mylistmodelbestellungen = new MyListModelBestellungen();

            mylistmodelbestellungen.setBestellunggrenzlist(bestellunggrenzlist);

            jTable1.setModel(mylistmodelbestellungen.buildTableModel());

            /* Listener Event aus Google */
            jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent event) {
                    // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                    // print first column value from selected row
                    String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();

                    hiddenValueForBestellung = Integer.parseInt(val);
                    lblOutput.setText("Bestellung : " + hiddenValueForBestellung);
                }
            });

            //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
            for (int c = 0; c < jTable1.getColumnCount(); c++) {
                Class<?> col_class = jTable1.getColumnClass(c);
                jTable1.setDefaultEditor(col_class, null);        // remove editor
            }
            jScrollPane1.setViewportView(jTable1);
            /* Listener Event aus Google */

        }
    }//GEN-LAST:event_searchDateActionPerformed

    private void fieldBisActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fieldBisActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fieldBisActionPerformed

    private void fieldVonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fieldVonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fieldVonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrameBestellungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrameBestellungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrameBestellungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrameBestellungenShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FrameBestellungenShow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bestellungPositionenShow;
    private javax.swing.JButton close;
    private javax.swing.JTextField fielById;
    private javax.swing.JTextField fieldBis;
    private javax.swing.JTextField fieldVon;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JLabel lblOutput;
    private javax.swing.JButton searchById;
    private javax.swing.JButton searchDate;
    // End of variables declaration//GEN-END:variables
}
